<?php

namespace OrganizationsManagement\Factory;

use Teknisa\Model\Teknisa\Entities\OmConfigColetaOrg;
use Teknisa\Model\Util\NovoCodigo;

class ConfigColetaOrg {

    /**
     * @param string $idAtivo
     * @param $currentUserId
     * @param $currentOrganizationId
     * @param $dateNow
     * @param $nrconfColId
     * @param $nrorgId
     * @return mixed
     */
    public function create($nrconfColId, $nrorgId, $idAtivo, $currentUserId, $currentOrganizationId, $dateNow) {

        /** @var \Teknisa\Model\Teknisa\Entities\OmConfigColetaOrg $omConfigColetaOrg */
        $omConfigColetaOrg = new OmConfigColetaOrg();
        $novoCodigo = NovoCodigo::geraCodigo($currentOrganizationId, 'OM_CONFIG_COLETA_ORG', 1, 10, true);
        $omConfigColetaOrg->setId($novoCodigo);
        $omConfigColetaOrg->setDtinclusao($dateNow);
        $omConfigColetaOrg->setNrorg($currentOrganizationId);
        $omConfigColetaOrg->setCdoperinclusao($currentUserId);
        $omConfigColetaOrg->setNrorginclusao($currentOrganizationId);
        $omConfigColetaOrg->setIdativo($idAtivo);
        $omConfigColetaOrg->setDtultatu($dateNow);
        $omConfigColetaOrg->setCdoperultatu($currentUserId);
        $omConfigColetaOrg->setNrorgultatu($currentOrganizationId);
        $omConfigColetaOrg->setNrconfcolId($nrconfColId);
        $omConfigColetaOrg->setNrorgId($nrorgId);

        return $omConfigColetaOrg;
    }
}