<?php
namespace OrganizationsManagement\Service\Email;
use OrganizationsManagement\Util\Mail\SmtpCore;

class EmailSenha {

    public function __construct(){}

    public function enviaEmailSenhaCriada($cdoperador, $nmoperador, $destino, $senha){
        $templateEmail = $this->obtemCaminhoTemplateSenhaGerada();
        $conteudoEmail = $this->traduzConteudoTemplate($templateEmail, $cdoperador, $destino, $senha);
        $assuntoEmail = $nmoperador . ', sua senha foi criada.';
        $smtpCore = new SmtpCore();
        $smtpCore->enviaHtml($destino, 'sac@teknisa.com', $assuntoEmail, $conteudoEmail);
    }

    public function enviaEmailSenhaRecriada($codigo, $nmoperador, $destino, $senha){
        $templateEmail = $this->obtemCaminhoTemplateSenhaRegerada();
        $conteudoEmail = $this->traduzConteudoTemplate($templateEmail, $codigo, $destino, $senha);
        $assuntoEmail = $nmoperador . ', sua senha foi redefinida';
        $smtpCore = new SmtpCore();
        $smtpCore->enviaHtml($destino, 'sac@teknisa.com', $assuntoEmail, $conteudoEmail);
    }

    private function traduzConteudoTemplate($template, $codigo, $email, $senha){
        $conteudoTraduzido = file_get_contents($template);
        $conteudoTraduzido = str_replace('%codigo%', $codigo, $conteudoTraduzido);
        $conteudoTraduzido = str_replace('%email%', $email, $conteudoTraduzido);
        $conteudoTraduzido = str_replace('%senha%', $senha, $conteudoTraduzido);
        return $conteudoTraduzido;
    }

    private function obtemCaminhoTemplateSenhaRegerada(){
        return $this->obtemEnderecoArquivoTemplateEmail() . 'senha_regerada.html';
    }

    private function obtemCaminhoTemplateSenhaGerada(){
        return $this->obtemEnderecoArquivoTemplateEmail() . 'senha_gerada.html';
    }

    private function obtemEnderecoArquivoTemplateEmail(){
        return __DIR__.'/../../Util/EmailTemplates/';
    }

} 