CREATE OR REPLACE TRIGGER GERA_LOGSERVICO AFTER INSERT OR UPDATE OR DELETE ON SERVPLANO
FOR EACH ROW
DECLARE
   V_CDLOGSERVICO VARCHAR2(20);
   V_IDTPMANUTLS  LOGSERVICO.IDTPMANUTLS%TYPE;
   V_NRDELIVERY   LOGSERVICO.NRDELIVERYLS%TYPE;
BEGIN
   IF (:NEW.NRDELIVERY IS NOT NULL) OR
      (:OLD.NRDELIVERY IS NOT NULL) THEN
      
      IF DELETING THEN
         NOVO_CODIGO_SC('LOGSERVICO'||:NEW.CDFILIAL||:NEW.CDCIA||:NEW.NRVOO||:NEW.CDTRECHO||TO_CHAR(:NEW.DTHRPLAVOOPV,'DD/MM/YYYY'),V_CDLOGSERVICO,1);
         V_CDLOGSERVICO := SUBSTR(V_CDLOGSERVICO,11,10);

         INSERT INTO LOGSERVICO
         (CDFILIAL,CDCIASERVLS,NRVOOLS,CDTRECHOLS,DTHRPLALS,
          CDSERVICOSLS,NRITEMSPLS,CDLOGSERVLS,DTHRINCLS,
          QTSESOLICLS,QTCORTSERVLS,QTATUAPRODLS,QTSESBYPRLS,
          IDSITSERLS,CDUSRRESPLS,DTHRCANCLS,QTSERFATLS,
          QTSERVFIXLS,NRDELIVERYLS,QTSESBYUTLS,IDSERVESPLS,
          NRLANCTONFLS,CDFILIALLS,IDTPMANUTLS)
         SELECT :OLD.CDFILIAL,:OLD.CDCIA,:OLD.NRVOO,:OLD.CDTRECHO,:OLD.DTHRPLAVOOPV,
                :OLD.CDSERVICO,:OLD.NRITEMPLANSP,V_CDLOGSERVICO,SYSDATE,
                :OLD.QTSESOLICSP,:OLD.QTCORTSERVSP,:OLD.QTATUAPRODSP,:OLD.QTSESBYPRSP,
                :OLD.IDSITSERSP,SUBSTR(:OLD.CDUSRRESPSP,3,10),:OLD.DTHRCANCSESP,:OLD.QTSERFATSP,
                :OLD.QTSERVFIXSP,:OLD.NRDELIVERY,:OLD.QTSESBYUTSP,SC.IDSERVESP,
                :OLD.NRLANCTONF,:OLD.CDFILIALNF,'06'
         FROM SERVICOCIA SC
         WHERE (CDSERVICO = :OLD.CDSERVICO);
      END IF;
      IF UPDATING THEN
         IF (TO_CHAR(:NEW.QTSESOLICSP )||'-' <> TO_CHAR(:OLD.QTSESOLICSP )||'-')  OR
            (TO_CHAR(:NEW.QTCORTSERVSP)||'-' <> TO_CHAR(:OLD.QTCORTSERVSP)||'-')  OR
            (TO_CHAR(:NEW.QTATUAPRODSP)||'-' <> TO_CHAR(:OLD.QTATUAPRODSP)||'-')  OR
            (TO_CHAR(:NEW.QTSESBYPRSP )||'-' <> TO_CHAR(:OLD.QTSESBYPRSP )||'-')  OR
            (TO_CHAR(:NEW.QTSESBYUTSP )||'-' <> TO_CHAR(:OLD.QTSESBYUTSP )||'-')  OR
            (TO_CHAR(:NEW.QTSERVFIXSP )||'-' <> TO_CHAR(:OLD.QTSERVFIXSP )||'-')  OR
            (TO_CHAR(:NEW.QTSERFATSP  )||'-' <> TO_CHAR(:OLD.QTSERFATSP  )||'-')  OR
            (TO_CHAR(:NEW.NRDELIVERY  )||'-' <> TO_CHAR(:OLD.NRDELIVERY  )||'-') THEN
             V_NRDELIVERY := :NEW.NRDELIVERY;
            NOVO_CODIGO_SC('LOGSERVICO'||:NEW.CDFILIAL||:NEW.CDCIA||:NEW.NRVOO||:NEW.CDTRECHO||TO_CHAR(:NEW.DTHRPLAVOOPV,'DD/MM/YYYY'),V_CDLOGSERVICO,1);
             V_CDLOGSERVICO := SUBSTR(V_CDLOGSERVICO,11,10);
            IF :OLD.NRDELIVERY IS NULL THEN
    	       V_IDTPMANUTLS := '02'; /* Incluso na Emisso do Delivery */
            ELSE
               IF (:NEW.NRDELIVERY IS NULL) OR (:NEW.NRDELIVERY = '') THEN
                  V_IDTPMANUTLS := '03'; /* Excluso por Cancelamento de Delivery */
         	  V_NRDELIVERY  := :OLD.NRDELIVERY;
               ELSE
                  V_IDTPMANUTLS := '05'; /* Alterao manual */
               END IF;
            END IF;
             INSERT INTO LOGSERVICO
             (CDFILIAL,CDCIASERVLS,NRVOOLS,CDTRECHOLS,DTHRPLALS,
              CDSERVICOSLS,NRITEMSPLS,CDLOGSERVLS,DTHRINCLS,
              QTSESOLICLS,QTCORTSERVLS,QTATUAPRODLS,QTSESBYPRLS,
              IDSITSERLS,CDUSRRESPLS,DTHRCANCLS,QTSERFATLS,
              QTSERVFIXLS,NRDELIVERYLS,QTSESBYUTLS,IDSERVESPLS,
              NRLANCTONFLS,CDFILIALLS,IDTPMANUTLS/*,CDCLASSELSRV,CDCICLOLSRV*/)
             SELECT :NEW.CDFILIAL,:NEW.CDCIA,:NEW.NRVOO,:NEW.CDTRECHO,:NEW.DTHRPLAVOOPV,
                    :NEW.CDSERVICO,:NEW.NRITEMPLANSP,V_CDLOGSERVICO,SYSDATE,
                    :NEW.QTSESOLICSP,:NEW.QTCORTSERVSP,:NEW.QTATUAPRODSP,:NEW.QTSESBYPRSP,
                    :NEW.IDSITSERSP,SUBSTR(:NEW.CDUSRRESPSP,3,10),:NEW.DTHRCANCSESP,:NEW.QTSERFATSP,
                    :NEW.QTSERVFIXSP,V_NRDELIVERY,:NEW.QTSESBYUTSP,SC.IDSERVESP,
                    :NEW.NRLANCTONF,:NEW.CDFILIALNF,V_IDTPMANUTLS/*,:NEW.CDCLASSE,:NEW.CDCICLO*/
             FROM SERVICOCIA SC
             WHERE (CDSERVICO = :NEW.CDSERVICO);
         END IF;
      END IF;
   END IF;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('GERA_LOGSERVICO','5.03.043'); END;
/

